
package cz.upol.pja.lecture08;

import javax.annotation.Resource;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.jms.JMSConnectionFactory;
import javax.jms.JMSContext;
import javax.jms.Queue;
import javax.jms.Topic;


@Named("actionCtl")
@RequestScoped
public class ActionCtl {
    
    @Inject
    @JMSConnectionFactory("java:comp/DefaultJMSConnectionFactory")
    private JMSContext context;
    
    
//    @Resource(mappedName = "jms/Lecture08Queue")
    @Resource(mappedName = "java:app/jms/myTextQueue")
    private Queue textQueue;

    @Resource(mappedName = "java:app/jms/newUserTopic")
    private Topic newUserTopic;
    
    
    private String firstName;
    private String secondName;
    private String message;
    
    public void enqueue1() {
        context.createProducer().send(textQueue, firstName + " " + secondName);
        message = "Ok 1";
    }

    public void enqueue2() throws Exception {
        context.createProducer().send(newUserTopic, new NewUserMsg(firstName, secondName));
        message = "Ok 2";
    }
    

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getSecondName() {
        return secondName;
    }

    public void setSecondName(String secondName) {
        this.secondName = secondName;
    }
}
